'''
Created on 6 de mar de 2017

@author: thiago
'''

# Maximo divisor comum binario
def gcd(a, b):
    # Preparo: retira fatores de 2 comuns,
    #  garante que ambos são ímpares e que a>b

    # Para o caso em que ambos são pares
    fator = 1;      
    while (a%2)==0 and (b%2)==0:
        a //= 2;
        b //= 2;
        fator *=2;
       
    # Agora, no maximo um deles é par
    while (a%2)==0:
        a//= 2;
    while (b%2)==0:
        b//= 2;
    
    if b>a:  # Garante a > b
        a, b = b, a

    # Código principal
    while a!=b:
        r = a - b
        while (r%2)==0: 
            r//= 2
        if r>b:
            a = r            
        else:     # Garante que a > b
            a = b
            b = r

    return fator*a 

def execute():
    print("GCD(2,3)=", gcd(2,3))
    print("GCD(15,6)=", gcd(15,6))
    print("GCD(256,32)=", gcd(256,32))
    print("GCD(257,954)=", gcd(257,954))

if __name__ == '__main__':
    execute()