'''7
Created on 6 de mar de 2017

@author: thiago
'''

def selecao(a):
    for i in range(len(a)):
        jmin=i
        min = a[i]
        for j in range(i+1, len(a)):
            if a[j] < min: 
                min = a[j]
                jmin = j
        temp = a[i]
        a[i] = min
        a[jmin] = temp
    
def insercao(a):
    for i in range(1, len(a)):
        temp=a[i];
        j = i
        while j > 0 and temp<a[j-1]:
            a[j]=a[j-1]
            j -= 1
        a[j]=temp        


def mergesort(a):
        temp = [None]*len(a)
        
        def merge(left, mid, right):
            i_left = left   # iterador da 1a metade do vetor de entrada
            i_right = mid   # iterador da 2a metade do vetor de entrada
            i_out = left    # iterador da posicao de saida
            while i_left < mid and i_right < right:
                if a[i_left] < a[i_right]:
                    temp[i_out] = a[i_left]
                    i_left += 1
                else:
                    temp[i_out] = a[i_right]
                    i_right += 1
                i_out += 1
            while i_left < mid:
                temp[i_out] = a[i_left]
                i_left += 1
                i_out += 1
            while i_right < right:
                temp[i_out] = a[i_right]
                i_right += 1
                i_out += 1
            # copia o conteudo em temp de volta 
            for i in range(left, right):
                a[i] = temp[i]
                            
        def mergesort_rec(left, right):
            if (left+1) < right:
                center = (left+right)//2
                mergesort_rec(left, center)
                mergesort_rec(center, right)
                merge(left, center, right)                
            
        mergesort_rec(0, len(a))
    
    
def quicksort_ext(s, a, b):
    if a>=b:
        return
    p = s[b]     # pivot
    l = a
    r = b-1
    while l<=r :
        while l<=r and s[l]<=p:
            l = l+1
        while l<=r and s[r]>=p:
            r = r - 1
        if l<r:
            temp = s[l]
            s[l] = s[r]
            s[r]=temp
    s[b] = s[l]
    s[l] = p
    quicksort_ext(s, a, (l-1))
    quicksort_ext(s, (l+1), b)
    
def quicksort(s):
    quicksort_ext(s, 0, len(s)-1)   
       
def execute():        
    base = [5, 6, 4, 7, 1, 3, 2, 9];
    
    x = list(base)
    selecao(x)
    print("Ordenação por selecao:", x)
    
    x = list(base)
    insercao(x)
    print("Ordenação por insercao:", x)
    
    x = list(base)
    mergesort(x)
    print("Ordenação por mergesort:", x)
    
    x = list(base)
    quicksort(x)
    print("Ordenação por quicksort:", x)
    

if __name__ == '__main__':
    execute()